import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public abstract class Animal  extends Actor
{

    /**
     * @author Michael Kolling
     */
    public Animal()
    {
    }

    public void act()
    {
    }

    public void turn(int angle)
    {
        setRotation(getRotation() + angle);
    }
    
    public void move(int g)
    {
        double angle = Math.toRadians( getRotation() );
        int x = (int) Math.round(getX() + Math.cos(angle) * g);
        int y = (int) Math.round(getY() + Math.sin(angle) * g);
        
        setLocation(x, y);
    }
    
    public void moveBack(int g)
    {
        double angle = Math.toRadians( getRotation() );
        int x = (int) Math.round(getX() + Math.cos(angle) * g * -1);
        int y = (int) Math.round(getY() + Math.sin(angle) * g * -1);
        
        setLocation(x, y);
    }

    public boolean atWorldEdge()
    {
        if(getX() < 20 || getX() > getWorld().getWidth() - 20)
            return true;
        if(getY() < 20 || getY() > getWorld().getHeight() - 20)
            return true;
        else
            return false;
    }

    public boolean canSee(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        return actor != null;        
    }

    public void eat(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        if(actor != null) {
            getWorld().removeObject(actor);
        }
    }
    
    
    public void randomWalk(int g)
    {
        
        if ( canSee(Platforms.class) )
        {
            turn(180);
            move(g);
        }
            if (Greenfoot.getRandomNumber(100) > 90)
            {
                turn(Greenfoot.getRandomNumber(90)-45);
            }
        
        move(g);
        
    }
    
    public void checkKeys(int f)
    {
            if(Greenfoot.isKeyDown("up"))
        {
            move(f);
        }
        
        
        if(Greenfoot.isKeyDown("down"))
        {
            moveBack(f);
        }
        
        if(Greenfoot.isKeyDown("right"))
        {
            turn(8);
        }
        
        if(Greenfoot.isKeyDown("left"))
        {
            turn(8*-1);
        }
    }

    
    public void checkMouse()
    {
        if(Greenfoot.mouseMoved(null))
       {
                MouseInfo mouse = Greenfoot.getMouseInfo();
                setLocation(mouse.getX(), mouse.getY());
       }
    }
}