import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The world of Gravix. Twenty levels of hand-drawn laser-filled bull.
 * 
 * @author SilverWings59
 */

public class Gravix  extends World
{

    private int level;
    private int counterX;
    private int counterY;
    private int deaths = 0;

    public Gravix()
    {    
        super(600, 600, 1); 
        
        levelZero();
    }
    
    public void Instructions()
    {
        removeObjects(getObjects(Actor.class));
        addObject(new Floor(0), 300, 5);
        addObject(new Floor(0), 300, 595);
        addObject(new Floor(90), 5, 300);
        addObject(new Floor(90), 595, 300);
        addObject(new Player(300, 564), 300, 564);
        addObject(new Title("back"), 100, 500);
        addObject(new Title("instructions"), 300, 300);
    }
        
    
    public void levelZero()
    {
        level = 0;
        deaths = 0;
        removeObjects(getObjects(Actor.class));
        addObject(new Floor(0), 300, 5);
        addObject(new Floor(0), 300, 595);
        addObject(new Floor(90), 5, 300);
        addObject(new Floor(90), 595, 300);
        addObject(new Player(300, 564), 300, 564);
        addObject(new Title("name"), 300, 200);
        addObject(new Title("play"), 100, 500);
        addObject(new Title("how"), 500, 500);
    }
    
    public void levelOne()
    {
        level = 1;
        counterX = 535;
        counterY = 54;
        removeObjects(getObjects(Actor.class));
        addObject(new Counter("Deaths: " + deaths), 535, 54);
        addObject(new Floor(0), 300, 5);
        addObject(new Floor(0), 300, 595);
        addObject(new Floor(90), 5, 300);
        addObject(new Floor(90), 595, 300);
        addObject(new Player(56, 564), 56, 564);
        addObject(new Platform(90), 133, 273);
        addObject(new Platform(90), 77, 155);
        addObject(new Star(), 214, 382);
        addObject(new ShiftUp(), 556, 560);
        addObject(new ShiftLeft(), 566, 39);
    }
    
    public void levelTwo()
    {
        level = 2;
        removeObjects(getObjects(Actor.class));
        counterX = 583;
        counterY = 54;
        addObject(new Counter("Deaths: " + deaths), 583, 54);
        addObject(new Floor(0), 300, 5);
        addObject(new Floor(0), 300, 595);
        addObject(new Floor(90), 5, 300);
        addObject(new Floor(90), 595, 300);
        addObject(new Player(56, 564), 56, 564);
        addObject(new ShiftUp(), 491, 560);
        addObject(new Cannon(0), 30, 300);
        addObject(new Star(), 491 , 44);
    }
    
    public void levelThree()
    {
        level = 3;
        counterX = 535;
        counterY = 54;
        removeObjects(getObjects(Actor.class));
        addObject(new Counter("Deaths: " + deaths), 535, 54);
        addObject(new Floor(0), 300, 5);
        addObject(new Floor(0), 300, 595);
        addObject(new Floor(90), 5, 300);
        addObject(new Floor(90), 595, 300);
        addObject(new Player(53, 560), 53, 560);
        addObject(new SuperLaser(0), 0, 478);
        addObject(new ShiftRight(), 246, 547);
        addObject(new Cannon(90), 370, 30);
        addObject(new Star(), 550, 550);
    }
    
    public void levelFour()
    {
        level = 4;
        counterX = 545;
        counterY = 54;
        removeObjects(getObjects(Actor.class));
        addObject(new Counter("Deaths: " + deaths), 545, 54);
        addObject(new Floor(0), 300, 5);
        addObject(new Floor(0), 300, 595);
        addObject(new Floor(90), 5, 300);
        addObject(new Floor(90), 595, 300);
        addObject(new Player(124, 406), 124, 406);
        addObject(new Platform(0), 124, 469);
        addObject(new Platform(0), 316, 469);
        addObject(new ShiftUp(), 524, 471);
        addObject(new Cannon(90), 224, 30);
        addObject(new Cannon(90), 449, 30);
        addObject(new Star(), 58, 36);
        addObject(new SuperLaser(0), 300, 552);
    }
    
    public void levelFive()
    {
        level = 5;
        counterX = 535;
        counterY = 54;
        removeObjects(getObjects(Actor.class));
        addObject(new Counter("Deaths: " + deaths), 535, 54);
        addObject(new Floor(0), 300, 5);
        addObject(new Floor(0), 300, 595);
        addObject(new Floor(90), 5, 300);
        addObject(new Floor(90), 595, 300);
        addObject(new Player(565, 560), 565, 560);
        addObject(new ShiftRight(), 49, 205);
        addObject(new ShiftUp(), 50, 308);
        addObject(new ShiftRight(), 48, 424);
        addObject(new ShiftUp(), 44, 545);
        addObject(new ShiftLeft(), 546, 100);
        addObject(new ShiftUp(), 546, 212);
        addObject(new ShiftLeft(), 551, 308);
        addObject(new ShiftUp(), 562, 419);
        addObject(new Enemy(), 209, 71);
        addObject(new Star(), 63, 75);
        addObject(new SuperLaser(0), 151, 149);
        addObject(new SuperLaser(0), 421, 267);
        addObject(new SuperLaser(0), 154, 386);
        addObject(new SuperLaser(0), 406, 512);
    }
    
    public void levelSix()
    {
        level = 6;
        counterX = 507;
        counterY = 54;
        removeObjects(getObjects(Actor.class));
        addObject(new Counter("Deaths: " + deaths), 507, 54);
        addObject(new Floor(0), 300, 5);
        addObject(new Floor(0), 300, 595);
        addObject(new Floor(90), 5, 300);
        addObject(new Floor(90), 595, 300);
        addObject(new Player(48, 548), 48, 548);
        addObject(new SuperLaser(0), 600, 123);
        addObject(new SuperLaser(0), 0, 400);
        addObject(new ShiftUp(), 548, 564);
        addObject(new ShiftLeft(), 552, 57);
        addObject(new Star(), 44, 348);
        addObject(new Enemy(), 300, 300);
        addObject(new Enemy(), 200, 200);
    }
    
    public void levelSeven()
    {
        level = 7;
        counterX = 403;
        counterY = 54;
        removeObjects(getObjects(Actor.class));
        addObject(new Counter("Deaths: " + deaths), 403, 54);
        addObject(new Floor(0), 300, 5);
        addObject(new Floor(0), 300, 595);
        addObject(new Floor(90), 5, 300);
        addObject(new Floor(90), 595, 300);
        addObject(new Player(173, 444), 173, 444);
        addObject(new SuperLaser(0), 415, 559);
        addObject(new SuperLaser(90), 86, 400);
        addObject(new Enemy(), 490, 89);
        addObject(new Enemy(), 216, 276);
        addObject(new ShiftLeft(), 159, 78);
        addObject(new Platform(0), 266, 167);
        addObject(new Platform(0), 409, 225);
        addObject(new Platform(0), 527, 338);
        addObject(new Platform(0), 410, 392);
        addObject(new Platform(0), 274, 449);
        addObject(new Platform(0), 148, 509);
        addObject(new Star(), 38, 561);
    }
    
    public void levelEight()
    {
        level = 8;
        counterX = 372;
        counterY = 54;
        removeObjects(getObjects(Actor.class));
        addObject(new Counter("Deaths: " + deaths), 372, 54);
        addObject(new Floor(0), 300, 5);
        addObject(new Floor(0), 300, 595);
        addObject(new Floor(90), 5, 300);
        addObject(new Floor(90), 595, 300);
        addObject(new Player(48, 548), 48, 548);
        addObject(new SuperLaser(0), 198, 495);
        addObject(new SuperLaser(90), 511, 63);
        addObject(new SuperLaser(90), 285, 63);
        addObject(new ShiftUp(), 561, 558);
        addObject(new ShiftDown(), 562, 51);
        addObject(new ShiftDown(), 458, 46);
        addObject(new ShiftLeft(), 345, 439);
        addObject(new ShiftUp(), 209, 441);
        addObject(new Star(), 127, 41);
        addObject(new Enemy(), 107, 219);
    }
    
    public void levelNine()
    {
        level = 9;
        counterX = 535;
        counterY = 54;
        removeObjects(getObjects(Actor.class));
        addObject(new Counter("Deaths: " + deaths), 535, 54);
        addObject(new Floor(0), 300, 5);
        addObject(new Floor(0), 300, 595);
        addObject(new Floor(90), 5, 300);
        addObject(new Floor(90), 595, 300);
        addObject(new Player(42, 552), 42, 552);
        addObject(new Floor(0), 200, 105);
        addObject(new Floor(0), 182, 512);
        addObject(new Floor(0), 402, 320);
        addObject(new Platform(0), 522, 219);
        addObject(new Platform(0), 336, 423);
        addObject(new Platform(0), 253, 218);
        addObject(new Platform(0), 54, 424);
        addObject(new Cannon(180), 570, 466);
        addObject(new Cannon(0), 30, 281);
        addObject(new Star(), 44, 59);
    }
    
    public void levelTen()
    {
        level = 10;
        counterX = 535;
        counterY = 54;
        removeObjects(getObjects(Actor.class));
        addObject(new Counter("Deaths: " + deaths), 535, 54);
        addObject(new Floor(0), 300, 5);
        addObject(new Floor(0), 300, 595);
        addObject(new Floor(90), 5, 300);
        addObject(new Floor(90), 595, 300);
        addObject(new Player(41, 52), 41, 52);
        addObject(new ShiftUp(), 37, 569);
        addObject(new SuperLaser(90), 91, 429);
        addObject(new ShiftRight(), 190, 161);
        addObject(new SuperLaser(0), 599, 533);
        addObject(new ShiftRight(), 130, 430);
        addObject(new ShiftLeft(), 567, 349);
        addObject(new Star(), 567, 498);
        addObject(new SuperLaser(0), 599, 465);
        addObject(new SuperLaser(90), 570, 0);
    }
    
    public void levelEleven()
    {
        level = 11;
        counterX = 535;
        counterY = 54;
        removeObjects(getObjects(Actor.class));
        addObject(new Counter("Deaths: " + deaths), 535, 54);
        addObject(new Floor(0), 300, 5);
        addObject(new Floor(0), 300, 595);
        addObject(new Floor(90), 5, 300);
        addObject(new Floor(90), 595, 300);
        addObject(new Player(92, 304), 92, 304);
        addObject(new Platform(0), 88, 371);
        addObject(new SuperLaser(0), 300, 30);
        addObject(new SuperLaser(0), 300, 570);
        addObject(new Star(), 552, 89);
        addObject(new Cannon(180), 570, 417);
        addObject(new ShiftUp(), 421, 471);
        addObject(new ShiftDown(), 304, 176);
        addObject(new ShiftUp(), 194, 472);
        addObject(new Enemy(), 498, 233);
        addObject(new Enemy(), 121, 147);
    }
    
    public void levelTwelve()
    {
        level = 12;
        counterX = 573;
        counterY = 113;
        removeObjects(getObjects(Actor.class));
        addObject(new Counter("Deaths: " + deaths), 573, 113);
        addObject(new Floor(0), 300, 5);
        addObject(new Floor(0), 300, 595);
        addObject(new Floor(90), 5, 300);
        addObject(new Floor(90), 595, 300);
        addObject(new Player(43, 543), 43, 543);
        addObject(new SuperLaser(0), 300, 50);
        addObject(new ShiftUp(), 100, 551);
        addObject(new ShiftUp(), 180, 551);
        addObject(new ShiftUp(), 260, 551);
        addObject(new ShiftUp(), 340, 551);
        addObject(new ShiftUp(), 420, 551);
        addObject(new ShiftUp(), 500, 551);
        addObject(new Star(), 560, 551);
        addObject(new Enemy(), 150, 200);
        addObject(new Enemy(), 300, 200);
        addObject(new Enemy(), 450, 200);
    }
    
    public void levelThirteen()
    {
        level = 13;
        counterX = 335;
        counterY = 54;
        removeObjects(getObjects(Actor.class));
        addObject(new Counter("Deaths: " + deaths), 335, 54);
        addObject(new Floor(0), 300, 5);
        addObject(new Floor(0), 300, 595);
        addObject(new Floor(90), 5, 300);
        addObject(new Floor(90), 595, 300);
        addObject(new Player(67, 476), 67, 476);
        addObject(new ShiftDown(), 183, 41);
        addObject(new ShiftUp(), 556, 564);
        addObject(new ShiftDown(), 424, 41);
        addObject(new ShiftUp(), 309, 558);
        addObject(new ShiftUp(), 60, 560);
        addObject(new Cannon(0), 30, 300);
        addObject(new SuperLaser(90), 505, 194);
        addObject(new SuperLaser(90), 380, 412);
        addObject(new SuperLaser(90), 253, 209);
        addObject(new SuperLaser(90), 125, 430);
        addObject(new Star(), 559, 41);
        addObject(new Enemy(), 63, 67);
        addObject(new Enemy(), 444, 535);
    }
    
    public void levelFourteen()
    {
        level = 14;
        counterX = 503;
        counterY = 24;
        removeObjects(getObjects(Actor.class));
        addObject(new Counter("Deaths: " + deaths), 503, 24);
        addObject(new Floor(0), 300, 5);
        addObject(new Floor(0), 300, 595);
        addObject(new Floor(90), 5, 300);
        addObject(new Floor(90), 595, 300);
        addObject(new Player(156, 320), 156, 320);
        addObject(new SuperLaser(0), 300, 50);
        addObject(new SuperLaser(0), 300, 550);
        addObject(new SuperLaser(90), 50, 300);
        addObject(new SuperLaser(90), 550, 300);
        addObject(new Platform(0), 157, 372);
        addObject(new Star(), 100, 100);
        addObject(new ShiftRight(), 163, 430);
        addObject(new ShiftUp(), 218, 510);
        addObject(new ShiftUp(), 500, 501);
        addObject(new ShiftLeft(), 501, 104);
        addObject(new ShiftDown(), 411, 201);
        addObject(new SuperLaser(0), 0, 175);
        addObject(new SuperLaser(90), 410, 600);
    }
    
    public void levelFifteen()
    {
        level = 15;
        counterX = 535;
        counterY = 54;
        removeObjects(getObjects(Actor.class));
        addObject(new Counter("Deaths: " + deaths), 535, 54);
        addObject(new Floor(0), 300, 5);
        addObject(new Floor(0), 300, 595);
        addObject(new Floor(90), 5, 300);
        addObject(new Floor(90), 595, 300);
        addObject(new Player(43, 543), 43, 543);
        addObject(new Cannon(0), 30, 250);
        addObject(new Cannon(90), 250, 30);
        addObject(new Cannon(180), 570, 350);
        addObject(new Cannon(270), 350, 570);
        addObject(new Enemy(), 450, 450);
        addObject(new Enemy(), 150, 150);
        addObject(new ShiftLeft(), 77, 42);
        addObject(new ShiftUp(), 555, 81);
        addObject(new ShiftRight(), 513, 560);
        addObject(new Star(), 42, 401);
    }
    
    public void levelSixteen()
    {
        level = 16;
        counterX = 535;
        counterY = 54;
        removeObjects(getObjects(Actor.class));
        addObject(new Counter("Deaths: " + deaths), 535, 54);
        addObject(new Floor(0), 300, 5);
        addObject(new Floor(0), 300, 595);
        addObject(new Floor(90), 5, 300);
        addObject(new Floor(90), 595, 300);
        addObject(new Player(112, 296), 112, 296);
        addObject(new Platform(0), 111, 359);
        addObject(new ShiftUp(), 182, 393);
        addObject(new ShiftUp(), 226, 393);
        addObject(new ShiftUp(), 270, 393);
        addObject(new ShiftUp(), 314, 393);
        addObject(new ShiftUp(), 358, 393);
        addObject(new ShiftUp(), 402, 393);
        addObject(new ShiftUp(), 446, 393);
        addObject(new ShiftUp(), 490, 393);
        addObject(new ShiftUp(), 534, 393);
        addObject(new ShiftDown(), 182, 220);
        addObject(new ShiftDown(), 226, 220);
        addObject(new ShiftDown(), 270, 220);
        addObject(new ShiftDown(), 314, 220);
        addObject(new ShiftDown(), 358, 220);
        addObject(new ShiftDown(), 402, 220);
        addObject(new ShiftDown(), 446, 220);
        addObject(new ShiftDown(), 490, 220);
        addObject(new ShiftDown(), 534, 220);
        addObject(new Cannon(90), 457, 30);
        addObject(new Cannon(90), 260, 30);
        addObject(new Star(), 567, 344);
    }
    
    public void levelSeventeen()
    {
        level = 17;
        counterX = 102;
        counterY = 54;
        removeObjects(getObjects(Actor.class));
        addObject(new Counter("Deaths: " + deaths), 102, 54);
        addObject(new Floor(0), 300, 5);
        addObject(new Floor(0), 300, 595);
        addObject(new Floor(90), 5, 300);
        addObject(new Floor(90), 595, 300);
        addObject(new Player(89, 457), 89, 457);
        addObject(new Cannon(90), 150, 30);
        addObject(new Cannon(90), 300, 30);
        addObject(new Cannon(90), 450, 30);
        addObject(new Cannon(0), 30, 150);
        addObject(new Cannon(0), 30, 300);
        addObject(new Cannon(0), 30, 450);
        addObject(new ShiftRight(), 89, 524);
        addObject(new SuperLaser(0), 317, 572);
        addObject(new SuperLaser(90), 568, 270);
        addObject(new ShiftRight(), 385, 91);
        addObject(new ShiftRight(), 89, 524);
        addObject(new ShiftLeft(), 413, 336);
        addObject(new ShiftUp(), 528, 514);
        addObject(new Platform(90), 210, 94);
        addObject(new Platform(90), 182, 246);
        addObject(new Platform(90), 264, 510);
        addObject(new Platform(0), 503, 334);
        addObject(new Platform(90), 412, 511);
        addObject(new Star(), 513, 34);
    }
    
    public void levelEighteen()
    {
        level = 18;
        counterX = 523;
        counterY = 14;
        removeObjects(getObjects(Actor.class));
        addObject(new Counter("Deaths: " + deaths), 523, 14);
        addObject(new Floor(0), 300, 5);
        addObject(new Floor(0), 300, 595);
        addObject(new Floor(90), 5, 300);
        addObject(new Floor(90), 595, 300);
        addObject(new Player(97, 420), 97, 420);
        addObject(new SuperLaser(0), 300, 560);
        addObject(new SuperLaser(0), 300, 40);
        addObject(new SuperLaser(90), 40, 300);
        addObject(new SuperLaser(90), 560, 300);
        addObject(new ShiftLeft(), 86, 265);
        addObject(new ShiftRight(), 94, 506);
        addObject(new ShiftDown(), 189, 433);
        addObject(new ShiftDown(), 276, 510);
        addObject(new ShiftDown(), 368, 447);
        addObject(new ShiftDown(), 448, 513);
        addObject(new ShiftUp(), 516, 517);
        addObject(new ShiftRight(), 521, 361);
        addObject(new ShiftRight(), 449, 291);
        addObject(new ShiftRight(), 509, 189);
        addObject(new ShiftLeft(), 517, 78);
        addObject(new ShiftUp(), 367, 87);
        addObject(new ShiftUp(), 296, 150);
        addObject(new ShiftUp(), 216, 87);
        addObject(new ShiftUp(), 147, 160);
        addObject(new ShiftDown(), 88, 86);
        addObject(new Star(), 82, 322);
    }
    
    public void levelNineteen()
    {
        level = 19;
        counterX = 535;
        counterY = 54;
        removeObjects(getObjects(Actor.class));
        addObject(new Counter("Deaths: " + deaths), 535, 54);
        addObject(new Floor(0), 300, 5);
        addObject(new Floor(0), 300, 595);
        addObject(new Floor(90), 5, 300);
        addObject(new Floor(90), 595, 300);
        addObject(new Player(565, 540), 565, 540);
        addObject(new ShiftUp(), 53, 75);
        addObject(new ShiftDown(), 52, 182);
        addObject(new ShiftLeft(), 519, 92);
        addObject(new ShiftDown(), 425, 154);
        addObject(new ShiftLeft(), 374, 274);
        addObject(new ShiftDown(), 298, 340);
        addObject(new ShiftRight(), 473, 535);
        addObject(new ShiftUp(), 563, 468);
        addObject(new SuperLaser(90), 521, 449);
        addObject(new SuperLaser(90), 424, 599);
        addObject(new SuperLaser(0), 285, 26);
        addObject(new SuperLaser(0), 0, 242);
        addObject(new SuperLaser(0), 31, 131);
        addObject(new Star(), 377, 554);
    }
    
    public void levelTwenty()
    {
        level = 20;
        counterX = 265;
        counterY = 54;
        removeObjects(getObjects(Actor.class));
        addObject(new Counter("Deaths: " + deaths), 265, 54);
        addObject(new Floor(0), 300, 5);
        addObject(new Floor(0), 300, 595);
        addObject(new Floor(90), 5, 300);
        addObject(new Floor(90), 595, 300);
        addObject(new Player(38, 540), 38, 540);
        addObject(new Platform(0), 100, 519);
        addObject(new Platform(0), 100, 395);
        addObject(new Platform(0), 100, 271);
        addObject(new Platform(0), 100, 147);
        addObject(new Cannon(0), 30, 333);
        addObject(new Platform(0), 333, 519);
        addObject(new Platform(0), 333, 395);
        addObject(new Platform(0), 333, 271);
        addObject(new Platform(0), 333, 147);
        addObject(new SuperLaser(90), 233, 421);
        addObject(new ShiftUp(), 102, 37);
        addObject(new Platform(0), 406, 40);
        addObject(new ShiftRight(), 333, 564);
        addObject(new SuperLaser(90), 471, 136);
        addObject(new Star(), 532, 37);
    }
    
    public void levelTwentyOne()
    {
        level = 21;
        removeObjects(getObjects(Actor.class));
        addObject(new Title("winner"), 292, 200);
        addObject(new Counter("You died " + deaths + " times. Pffft, bet I could beat that."), 481, 350);
        addObject(new SuperLaser(0), 300, 579);
        addObject(new Player(40, 411), 40, 411);
        addObject(new Player(40, 411), 235, 411);
        addObject(new Player(40, 411), 133, 411);
        addObject(new Player(40, 411), 340, 411);
        addObject(new Floor(0), 99, 444);
    }
    
    public void addLevel()
    {
        level++;
        
        if(level == 0) levelZero();
        if(level == 1) levelOne();
        if(level == 2) levelTwo();
        if(level == 3) levelThree();
        if(level == 4) levelFour();
        if(level == 5) levelFive();
        if(level == 6) levelSix();
        if(level == 7) levelSeven();
        if(level == 8) levelEight();
        if(level == 9) levelNine();
        if(level == 10) levelTen();
        if(level == 11) levelEleven();
        if(level == 12) levelTwelve();
        if(level == 13) levelThirteen();
        if(level == 14) levelFourteen();
        if(level == 15) levelFifteen();
        if(level == 16) levelSixteen();
        if(level == 17) levelSeventeen();
        if(level == 18) levelEighteen();
        if(level == 19) levelNineteen();
        if(level == 20) levelTwenty();
        if(level == 21) levelTwentyOne();
    }
    
    public int getLevel()
    {
        return level;
    }
    
    public void addDeath()
    {
        deaths++;
        
        removeObjects(getObjects(Counter.class));
        addObject(new Counter("Deaths: " + deaths), counterX, counterY);
    }
}
