import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Player  extends Animal
{

    private int x;
    private int y;
    private int jumping;
    private int counter;
    private String shift = "down";
    private final int speed = 3;
    private final int gravity = 5;
    private final int jump = 11;
    private int invincibility = 0;
    private boolean crouching = false;
    private int respawnX;
    private int respawnY;
    private GreenfootImage crouch = new GreenfootImage("crouching.png"); 
    private GreenfootImage jumpingleft = new GreenfootImage("jumpingleft.png"); 
    private GreenfootImage jumpingright = new GreenfootImage("jumpingright.png");
    private GreenfootImage jumpingup = new GreenfootImage("jumpingup.png"); 
    private GreenfootImage runningleft1 = new GreenfootImage("runningleft1.png");
    private GreenfootImage runningleft2 = new GreenfootImage("runningleft2.png"); 
    private GreenfootImage runningleft3 = new GreenfootImage("runningleft3.png"); 
    private GreenfootImage runningright1 = new GreenfootImage("runningright1.png");
    private GreenfootImage runningright2 = new GreenfootImage("runningright2.png"); 
    private GreenfootImage runningright3 = new GreenfootImage("runningright3.png"); 
    private GreenfootImage standing = new GreenfootImage("standing.png"); 
    
    public Player(int t, int f)
    {
        respawnX = t;
        respawnY = f;
        setImage(standing);
    }
    
    public Player()
    {
    }
    
    public void act() 
    {
        if( ((Gravix)getWorld()).getLevel() == 21)
        {
            winner();
        }
        else
        {
            if(canSee(ShiftUp.class)) shift = "up";
            if(canSee(ShiftDown.class)) shift = "down";
            if(canSee(ShiftLeft.class)) shift = "left";
            if(canSee(ShiftRight.class)) shift = "right";
            
            if(shift == "up") gravityUp();
            if(shift == "down") gravityDown();
            if(shift == "left") gravityLeft();
            if(shift == "right") gravityRight();
            
            invincibility--;
            
            if(invincibility < 0) die();
            win();
        }
    }    
    
    public void win()
    {
        if(canSee(Star.class))
        {
            ((Gravix)getWorld()).addLevel();
        }
    }
    
    public void die()
    {
        
        if(canSee(Enemy.class))
        {
            jumping = 0;
            shift = "down";
            crouching = false;
            invincibility = 30;
            Greenfoot.playSound("Explosion.wav");
            getWorld().addObject(new Explosion(), x, y);
            ((Gravix)getWorld()).addDeath();
            setLocation(respawnX, respawnY);
        }
        
        if(canSee(Shooter.class))
        {
            jumping = 0;
            shift = "down";
            crouching = false;
            invincibility = 30;
            Greenfoot.playSound("Explosion.wav");
            getWorld().addObject(new Explosion(), x, y);
            ((Gravix)getWorld()).addDeath();
            setLocation(respawnX, respawnY);
        }
    }
            
    
    public boolean onGround()
    {
        Object above = getOneObjectAtOffset(0, 32, Platforms.class);
        return above != null;
    }
    
    public boolean belowGround()
    {
        Object below = getOneObjectAtOffset(0, -32, Platforms.class);
        return below != null;
    }
    
    public boolean onRightWall()
    {
        Object right = getOneObjectAtOffset(32, 0, Platforms.class);
        return right != null;
    }
    
    public boolean onLeftWall()
    {
        Object left = getOneObjectAtOffset(-32, 0, Platforms.class);
        return left != null;
    }
    
    public void gravityDown()
    {
        x = getX();
        y = getY();
        setRotation(0);
        jumping--;
        
        if(!onGround()) y = y + gravity;
        
        if(Greenfoot.isKeyDown("down") && onGround()){
            setImage(crouch);
            crouching = true;
        }
        
        if(Greenfoot.isKeyDown("left") && !crouching)
        {
            x = x - speed;
            
            if (getImage() == runningleft1){
                counter ++;
                if (counter == 6){
                    setImage(runningleft2);
                    counter = 0;
                }
            }
            else if(getImage() == runningleft2){
                counter++;
                if (counter == 6){
                    setImage(runningleft3);
                    counter = 0;
                }
            }
            else if(getImage() == runningleft3){
                counter++;
                if(counter == 6){
                    setImage(runningleft1);
                    counter = 0;
                }
            }
            else setImage(runningleft1);
        }
        else if ( Greenfoot.isKeyDown("right") && !crouching)
        {
            x = x + speed;
            
            if (getImage() == runningright1){
                counter ++;
                if (counter == 6){
                    setImage(runningright2);
                    counter = 0;
                }
            }
            else if(getImage() == runningright2){
                counter++;
                if (counter == 6){
                    setImage(runningright3);
                    counter = 0;
                }
            }
            else if(getImage() == runningright3){
                counter++;
                if(counter == 6){
                    setImage(runningright1);
                    counter = 0;
                }
            }
            else setImage(runningright1);
        }
        
        if(Greenfoot.isKeyDown("up") && onGround() && !crouching) jumping = 20;
        
        if(belowGround()) jumping = 0;
        
        if( jumping > 1)
        {
            if(Greenfoot.isKeyDown("right"))
            {
                setImage(jumpingright);
            }
            else if (Greenfoot.isKeyDown("left"))
            {
                setImage(jumpingleft);
            }
            else
            {
                setImage(jumpingup);
            }
            
            y = y - jump;
        }
        
        if(!Greenfoot.isKeyDown("up") && !Greenfoot.isKeyDown("down") && !Greenfoot.isKeyDown("left") && !Greenfoot.isKeyDown("right")) setImage(standing);
        crouching = false;
        setLocation(x , y);
    }
    
    public void gravityUp()
    {
        x = getX();
        y = getY();
        setRotation(180);
        jumping--;
        
        if(!belowGround()) y = y - gravity;
        
        if(Greenfoot.isKeyDown("down") && belowGround()){
            setImage(crouch);
            crouching = true;
        }
        
        if(Greenfoot.isKeyDown("left") && !crouching)
        {
            x = x + speed;
            
            if (getImage() == runningleft1){
                counter ++;
                if (counter == 6){
                    setImage(runningleft2);
                    counter = 0;
                }
            }
            else if(getImage() == runningleft2){
                counter++;
                if (counter == 6){
                    setImage(runningleft3);
                    counter = 0;
                }
            }
            else if(getImage() == runningleft3){
                counter++;
                if(counter == 6){
                    setImage(runningleft1);
                    counter = 0;
                }
            }
            else setImage(runningleft1);
        }
        else if ( Greenfoot.isKeyDown("right") && !crouching)
        {
            x = x - speed;
            
            if (getImage() == runningright1){
                counter ++;
                if (counter == 6){
                    setImage(runningright2);
                    counter = 0;
                }
            }
            else if(getImage() == runningright2){
                counter++;
                if (counter == 6){
                    setImage(runningright3);
                    counter = 0;
                }
            }
            else if(getImage() == runningright3){
                counter++;
                if(counter == 6){
                    setImage(runningright1);
                    counter = 0;
                }
            }
            else setImage(runningright1);
        }
        
        if(Greenfoot.isKeyDown("up") && belowGround() && !crouching) jumping = 20;
        
        if(onGround()) jumping = 0;
        
        if( jumping > 1)
        {
            if(Greenfoot.isKeyDown("right"))
            {
                setImage(jumpingright);
            }
            else if (Greenfoot.isKeyDown("left"))
            {
                setImage(jumpingleft);
            }
            else
            {
                setImage(jumpingup);
            }
            
            y = y + jump;
        }
        
        if(!Greenfoot.isKeyDown("up") && !Greenfoot.isKeyDown("down") && !Greenfoot.isKeyDown("left") && !Greenfoot.isKeyDown("right")) setImage(standing);
        crouching = false;
        setLocation(x , y);
    }
    
    public void gravityLeft()
    {
        x = getX();
        y = getY();
        setRotation(90);
        jumping--;
        
        if(!onLeftWall()) x = x - gravity;
        
        if(Greenfoot.isKeyDown("down") && onLeftWall()){
            setImage(crouch);
            crouching = true;
        }
        
        if(Greenfoot.isKeyDown("right") && !crouching)
        {
            y = y + speed;
            
            if (getImage() == runningright1){
                counter ++;
                if (counter == 6){
                    setImage(runningright2);
                    counter = 0;
                }
            }
            else if(getImage() == runningright2){
                counter++;
                if (counter == 6){
                    setImage(runningright3);
                    counter = 0;
                }
            }
            else if(getImage() == runningright3){
                counter++;
                if(counter == 6){
                    setImage(runningright1);
                    counter = 0;
                }
            }
            else setImage(runningright1);
        }
        else if ( Greenfoot.isKeyDown("left") && !crouching)
        {
            y = y - speed;
            
            if (getImage() == runningleft1){
                counter ++;
                if (counter == 6){
                    setImage(runningleft2);
                    counter = 0;
                }
            }
            else if(getImage() == runningleft2){
                counter++;
                if (counter == 6){
                    setImage(runningleft3);
                    counter = 0;
                }
            }
            else if(getImage() == runningleft3){
                counter++;
                if(counter == 6){
                    setImage(runningleft1);
                    counter = 0;
                }
            }
            else setImage(runningleft1);
        }
        
        if(Greenfoot.isKeyDown("up") && onLeftWall() && !crouching) jumping = 20;
        
        if(onRightWall()) jumping = 0;
        
        if( jumping > 1)
        {
            if(Greenfoot.isKeyDown("right"))
            {
                setImage(jumpingright);
            }
            else if (Greenfoot.isKeyDown("left"))
            {
                setImage(jumpingleft);
            }
            else
            {
                setImage(jumpingup);
            }
            
            x = x + jump;
        }
        
        if(!Greenfoot.isKeyDown("up") && !Greenfoot.isKeyDown("down") && !Greenfoot.isKeyDown("left") && !Greenfoot.isKeyDown("right")) setImage(standing);
        crouching = false;
        setLocation(x , y);
    }
    
    public void gravityRight()
    {
        x = getX();
        y = getY();
        setRotation(270);
        jumping--;
        
        if(!onRightWall()) x = x + gravity;
        
        if(Greenfoot.isKeyDown("down") && onRightWall()){
            setImage(crouch);
            crouching = true;
        }
        
        if(Greenfoot.isKeyDown("right") && !crouching)
        {
            y = y - speed;
            
            if (getImage() == runningright1){
                counter ++;
                if (counter == 6){
                    setImage(runningright2);
                    counter = 0;
                }
            }
            else if(getImage() == runningright2){
                counter++;
                if (counter == 6){
                    setImage(runningright3);
                    counter = 0;
                }
            }
            else if(getImage() == runningright3){
                counter++;
                if(counter == 6){
                    setImage(runningright1);
                    counter = 0;
                }
            }
            else setImage(runningright1);
        }
        else if ( Greenfoot.isKeyDown("left") && !crouching)
        {
            y = y + speed;
            
            if (getImage() == runningleft1){
                counter ++;
                if (counter == 6){
                    setImage(runningleft2);
                    counter = 0;
                }
            }
            else if(getImage() == runningleft2){
                counter++;
                if (counter == 6){
                    setImage(runningleft3);
                    counter = 0;
                }
            }
            else if(getImage() == runningleft3){
                counter++;
                if(counter == 6){
                    setImage(runningleft1);
                    counter = 0;
                }
            }
            else setImage(runningleft1);
        }
        
        if(Greenfoot.isKeyDown("up") && onRightWall() && !crouching) jumping = 20;
        
        if(onLeftWall()) jumping = 0;
        
        if( jumping > 1)
        {
            if(Greenfoot.isKeyDown("right"))
            {
                setImage(jumpingright);
            }
            else if (Greenfoot.isKeyDown("left"))
            {
                setImage(jumpingleft);
            }
            else
            {
                setImage(jumpingup);
            }
            
            x = x - jump;
        }
        
        if(!Greenfoot.isKeyDown("up") && !Greenfoot.isKeyDown("down") && !Greenfoot.isKeyDown("left") && !Greenfoot.isKeyDown("right")) setImage(standing);
        crouching = false;
        setLocation(x , y);
    }
    
    public void winner()
    {
        x = getX();
        y = getY();
        
        if (getImage() == runningright1){
                counter ++;
                if (counter == 6){
                    setImage(runningright2);
                    counter = 0;
                }
            }
            else if(getImage() == runningright2){
                counter++;
                if (counter == 6){
                    setImage(runningright3);
                    counter = 0;
                }
            }
            else if(getImage() == runningright3){
                counter++;
                if(counter == 6){
                    setImage(runningright1);
                    counter = 0;
                }
            }
            else setImage(runningright1);
            
            x = x + speed;
            
            if(!onGround()) y = y + gravity;
            
            setLocation(x, y);
            
            if(canSee(Shooter.class))
            {
                Greenfoot.playSound("Explosion.wav");
                getWorld().addObject(new Explosion(), x, y);
                setLocation(respawnX, respawnY);
        }
            
        }
            
    
}
